<template>
  <div>
    <div class="gva-form-box">
      <el-form :model="formData" ref="elFormRef" label-position="right" :rules="rule" label-width="80px">
        <el-form-item label="交易金额:" prop="amount">
          <el-input-number v-model="formData.amount" :precision="2" :clearable="false"></el-input-number>
        </el-form-item>
        <el-form-item label="交易hash:" prop="hash">
          <el-input v-model="formData.hash" :clearable="false" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="交易时间:" prop="block_time">
          <el-date-picker v-model="formData.block_time" type="date" placeholder="选择日期" :clearable="false"></el-date-picker>
        </el-form-item>
        <el-form-item label="交易高度:" prop="height">
          <el-input v-model.number="formData.height" :clearable="false" placeholder="请输入" />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="save">保存</el-button>
          <el-button type="primary" @click="back">返回</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
export default {
  name: 'RedPackageTx'
}
</script>

<script setup>
import {
  createRedPackageTx,
  updateRedPackageTx,
  findRedPackageTx
} from '@/api/airDropRedPackageTx'

// 自动获取字典
import { getDictFunc } from '@/utils/format'
import { useRoute, useRouter } from "vue-router"
import { ElMessage } from 'element-plus'
import { ref, reactive } from 'vue'
const route = useRoute()
const router = useRouter()

const type = ref('')
const formData = ref({
            amount: 0,
            hash: '',
            block_time: new Date(),
            height: 0,
        })
// 验证规则
const rule = reactive({
               amount : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               hash : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               block_time : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               height : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
})

const elFormRef = ref()

// 初始化方法
const init = async () => {
 // 建议通过url传参获取目标数据ID 调用 find方法进行查询数据操作 从而决定本页面是create还是update 以下为id作为url参数示例
    if (route.query.id) {
      const res = await findRedPackageTx({ ID: route.query.id })
      if (res.code === 0) {
        formData.value = res.data.retx
        type.value = 'update'
      }
    } else {
      type.value = 'create'
    }
}

init()
// 保存按钮
const save = async() => {
      elFormRef.value?.validate( async (valid) => {
         if (!valid) return
            let res
           switch (type.value) {
             case 'create':
               res = await createRedPackageTx(formData.value)
               break
             case 'update':
               res = await updateRedPackageTx(formData.value)
               break
             default:
               res = await createRedPackageTx(formData.value)
               break
           }
           if (res.code === 0) {
             ElMessage({
               type: 'success',
               message: '创建/更改成功'
             })
           }
       })
}

// 返回按钮
const back = () => {
    router.go(-1)
}

</script>

<style>
</style>
